; $Id: fct.scm,v 1.2 1994/11/22 10:41:22 uwe Exp $
; Scheme examples

; a pair
(define pair (cons 1 2))

; 2 lists
(define l123 (list 1 2 3))
(define l-22 (list -2 -1 0 1 2))

; the square function
(define (sqr x) (* x x))

; faculty : try with 0, 1, 10, 100, 1000
(define (fac x) (if (= 0 x)
                 1
                 (* x (fac (- x 1 )))))

; a function 'plus' returning a function
(define (plus x) (lambda (y) (+ x y)))

; two functions computed with 'plus'
(define incr (plus 1))
(define plus2 (plus 2))

; a function 'fold' for generating list functions
(define (fold null f g) 
  (letrec ((fct (lambda (l) 
                   (if (null? l)
                       null
                       (g (f (car l)) (fct (cdr l)))
                   )
                )
          ))
   fct
  )
)

; functions generated with 'fold'
; -- sum of squares
; -- sum
; -- add 1 to every element
; -- test all elements positiv

(define qsum    (fold 0   sqr                         +      ))

(define sum     (fold 0   (lambda (x) x)              +      ))

(define add1    (fold '() (lambda (x) (list (+ x 1))) append ))

(define all-pos (fold #t  (lambda (x) (<= 0 x))       (lambda (x y) (and x y))     ))

